# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, playerlib, gamethread
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func     = es.import_addon('sam/functions')
pcontrol = es.import_addon('sam/core/pcontrol')
monitor  = es.import_addon('sam/core/monitor')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
temp = {'time':5,'active':False}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMDS
	func.ServerCMD('sam_spawnp_time', timeCMD)

	# CFG
	lib = {'sam_spawnp_time':{'value':temp['time'],'description':'Time in seconds of the duration on Spawn Protection.'}}
	monitor.cfg('spawnp', lib)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMDS
	func.unServerCMD('sam_spawnp_time')

	# CANCEL DELAY
	gamethread.cancelDelayed('sam_spawnp_delay')

	takeall()

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def loop(DELAY):
	if DELAY > 0:
		func.hudhint('#all','Protected for %s second/s.' % DELAY,'Spawn Protection')
		gamethread.delayedname(1,'sam_spawnp_delay',loop,(DELAY-1))
	else:
		func.hudhint('#all','Spawn protection ended.','Spawn Protection')
		temp['active'] = False
		takeall()
		gamethread.cancelDelayed('sam_spawnp_delay')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def giveall():
	for x in playerlib.getPlayerList('#alive'):
		if x.userid in pcontrol.DATA: pcontrol.add(x)
		pcontrol.DATA[x.userid]['Godmode'] = True
		pcontrol.god(x, False)
		if x.teamid == 2: x.setColor(200,0,0,175)
		elif x.teamid == 3: x.setColor(0,0,200,175)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def takeall():
	for x in playerlib.getPlayerList('#alive'):
		if x.userid in pcontrol.DATA: pcontrol.add(x)
		pcontrol.DATA[x.userid]['Godmode'] = False
		pcontrol.ungod(x, False)
		x.setColor(255,255,255,255)

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def timeCMD(ARGS):
	if ARGS:
		args = str(' '.join(ARGS))
		if args.isdigit(): temp['time'] = int(args)

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def round_freeze_end(ev):
	temp['active'] = True
	giveall()
	loop(temp['time'])

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_spawn(ev):
	if temp['active']:
		if x.userid in pcontrol.DATA: pcontrol.add(x)
		pcontrol.DATA[x.userid]['Godmode'] = True
		pcontrol.god(x, False)
		if x.teamid == 2: x.setColor(150,0,0,150)
		elif x.teamid == 3: x.setColor(0,0,150,150)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def round_end(ev):
	temp['active'] = False
	gamethread.cancelDelayed('sam_spawnp_delay')

# =============================================================================== #